<?php
namespace OrganizationsManagement\Factory;

use Teknisa\Model\Geral\Entities\Organizacao as EntidadeOrganizacao;
use OrganizationsManagement\Util;
use Setforms2\Shared\ORM\DateTime as SetformsDateTime;

class Organizacao {
    public function __construct(){}

    public function atualiza( EntidadeOrganizacao $entity, $companyName, $fantasyName, $type, $legalInscriptionNumber,
                              $isActive, $dsemailoper, $nmoperador, $nmacesso,
                              $streetName, $number, $complement, $cep, $countryId, $stateSymbol, $cityId, $neighborhood,
                              $cityInscription, $stateInscription, $nrParcNegocio = null, $idOrgSaas, $prepStatus, $nrOrgPrincipal) {
        if($type == EntidadeOrganizacao::PESSOA_JURIDICA || $type == EntidadeOrganizacao::PESSOA_FISICA) {
            $legalInscriptionNumber = Util\Utilities::removeCaracteresEspeciais($legalInscriptionNumber);
        }
        $entity->setDtultatu(new SetformsDateTime());

        $entity->setNmrazsocialorg($companyName);
        $entity->setNmorganizacao($fantasyName);
        $entity->setIdtipoinscrorg($type);
        $entity->setNrinsjurempr($legalInscriptionNumber);
        $entity->setIdativo($isActive);
        $entity->setNrparcnegocio($nrParcNegocio);

        $entity->setNmacesso($nmacesso);
        $entity->setDsemailoper($dsemailoper);
        $entity->setNmoperador($nmoperador);

        $entity->setDslogradempr($streetName);
        $entity->setNrlogradempr($number);
        $entity->setDscmplogempr($complement);
        $entity->setNrcepempr($cep);
        $entity->setCdpais($countryId);
        $entity->setSgestado($stateSymbol);
        $entity->setCdmunicipio($cityId);
        $entity->setNmbairempr($neighborhood);

        $entity->setCdinscmuni($cityInscription);
        $entity->setNrinscesta($stateInscription);

        $entity->setIdorgsaas($idOrgSaas);
        $entity->setNrorgprincipal($nrOrgPrincipal);

        if(in_array($prepStatus, EntidadeOrganizacao::getStatusIniciais())) {
            if($entity->isSecundaria()) {
                $entity->setPrepstatus(EntidadeOrganizacao::PREPARACAO_PENDENTE_SECUNDARIA);
            } else if($entity->isSaas()) {
                $entity->setPrepstatus(EntidadeOrganizacao::GERAR_ESTRUTURA);
            } else {
                $entity->setPrepstatus(EntidadeOrganizacao::PREPARACAO_PENDENTE_LOCAL_HOSTING);
            }
        } else {
            $entity->setPrepstatus($prepStatus);
        }

        return $entity;
    }

    public function cria($id, $companyName, $fantasyName, $type, $inscriptionNumber, $legalInscriptionNumber, $isActive,
                         $dsemailoper, $nmoperador, $nmacesso, $streetName, $number, $complement, $cep, $countryId,
                         $stateSymbol, $cityId, $neighborhood, $cityInscription, $stateInscription, $nrParcNegocio = null, $idOrgSaas, $nrOrgPrincipal) {
        if($type == EntidadeOrganizacao::PESSOA_JURIDICA || $type == EntidadeOrganizacao::PESSOA_FISICA) {
            $legalInscriptionNumber = Util\Utilities::removeCaracteresEspeciais($legalInscriptionNumber);
        }
        $entity = new EntidadeOrganizacao();

        $entity->setNrorg($id);
        $entity->setNrinscricaoorg($inscriptionNumber);

        $entity->setIdtipoinscrorg($type);
        $entity->setNmrazsocialorg($companyName);
        $entity->setNmorganizacao($fantasyName);
        $entity->setIdativo($isActive);
        $entity->setNrinsjurempr($legalInscriptionNumber);
        $entity->setNrparcnegocio($nrParcNegocio);

        $entity->setNmacesso($nmacesso);
        $entity->setDsemailoper($dsemailoper);
        $entity->setNmoperador($nmoperador);

        $entity->setDslogradempr($streetName);
        $entity->setNrlogradempr($number);
        $entity->setDscmplogempr($complement);
        $entity->setNrcepempr($cep);
        $entity->setCdpais($countryId);
        $entity->setSgestado($stateSymbol);
        $entity->setCdmunicipio($cityId);
        $entity->setNmbairempr($neighborhood);

        $entity->setCdinscmuni($cityInscription);
        $entity->setNrinscesta($stateInscription);
        
        $entity->setIdorgsaas($idOrgSaas);
        $entity->setNrorgprincipal($nrOrgPrincipal);

        if($entity->isSecundaria()) {
            $entity->setPrepstatus(EntidadeOrganizacao::PREPARACAO_PENDENTE_SECUNDARIA);
        } else if($entity->isSaas()) {
            $entity->setPrepstatus(EntidadeOrganizacao::GERAR_ESTRUTURA);
        } else {
            $entity->setPrepstatus(EntidadeOrganizacao::PREPARACAO_PENDENTE_LOCAL_HOSTING);
        }

        $entity->setDtinclusao(new SetformsDateTime());
        $entity->setDtultatu(new SetformsDateTime());

        return $entity;
    }

    public function saveScoreOrganization(EntidadeOrganizacao $e, $operador, $data, $idaltnrscore) {
        $e->setNrscore($data['NRSCORE']);
        $e->setIdalerta($data['IDALERTA']);
        $e->setDsdiretprclie($data['DSDIRETORCLIE']);
        $e->setDsrespticlie($data['DSRESPTICLIE']);
        $e->setCdoperpadrinho($data['CDOPERPADRINHO']);
        $e->setCdopergerente($data['CDOPERGERENTE']);
        $e->setIdopergerproj($data['IDOPERGERPROJ']);

        $e->setCdoperultatu($operador);
        $e->setDtultatu(new SetformsDateTime());
        $e->setIdaltnrscore($idaltnrscore);

        return $e;
    }
    
    public function saveNrScore(EntidadeOrganizacao $e, $data) {
        $e->setNrscore($data['NRSCORE']);
        return $e;
    }
}
