<?php


namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class ConsultaOperadorSAAS
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * ConsultaOperadorSAAS constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findOrganization()
    {
        $query = <<<SQL
            SELECT *FROM ORGANIZACAO
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }

    public function getOperadorSAAS()
    {
        $query = <<<SQL
            SELECT S.CDOPERADOR, S.NMOPERADOR, O.NMORGANIZACAO, S.NRORG, O.NMRAZSOCIALORG, S.DSEMAILOPER
            FROM USR_ORG_SAAS.operador S
            JOIN ORGANIZACAO O ON S.NRORG = O.NRORG
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}