<?php


namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\ORM\Query;
use Teknisa\Model\Traits\TQuery;

class Organization
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getOrganizationScore($minRevenue) {
        /*BUG ORACLE coloquei a tabela direto OM_PARAM_ORG, mas estava zerando o VRCNPJFATU... ai ficou assim*/
        $join = "LEFT JOIN (SELECT OPO.* FROM ORGANIZACAO O JOIN OM_PARAM_ORG OPO ON (O.NRORG = OPO.NRORG)) OPO ON (O.NRORG = OPO.NRORG)";
        $query = <<<SQL
      SELECT *
          FROM ( SELECT O.NRORG, O.NMRAZSOCIALORG, O.NMORGANIZACAO, O.PREPSTATUS, O.IDATIVO, CLI.NRPARCNEGOCIO,
                        O.IDTIPOINSCRORG, O.NRORGPRINCIPAL, O.PREPSTATUS AS ORGSTATUS, 
                        TO_NUMBER(NVL(OPO.VRCNPJFATU, 0)) AS VRCNPJFATU, TO_NUMBER(NVL(OPO.VRTOTALFATU, 0)) AS VRTOTALFATU,
                        DECODE(O.NRORGPRINCIPAL, NULL, 'P', 'S') AS IS_PRIMARY, O.IDALTNRSCORE,
                        DECODE(O.NRORGPRINCIPAL, NULL, O.IDORGSAAS, OM.IDORGSAAS) AS IDORGSAAS, NVL(O.IDALERTA, 'N') AS IDALERTA,
                        O.DSDIRETORCLIE, O.DSRESPTICLIE, O.CDOPERPADRINHO, O.CDOPERGERENTE, O.IDOPERGERPROJ,
                        OP1.NMOPERADOR AS NMOPERPADRINHO, OP2.NMOPERADOR AS NMOPERGERENTE, OPO.VROVERDUE, CLI.DTVALARQPERS, CLI.NRDIAVALPERS,
                        CASE WHEN (OPO.VROVERDUE > 0 )
                             THEN 'S' 
                             ELSE 'N'
                        END AS OVERDUE,
                        CASE WHEN (CLI.NRDIAVALPERS = 0 AND CLI.DTVALARQPERS IS NOT NULL )
                             THEN 'S'
                             ELSE 'N'
                        END AS CONTROL_PER,
                        CASE WHEN CLI.NRDIAVALPERS = 0
                             THEN CLI.DTVALARQPERS
                             ELSE null
                        END AS DATE_CONTROL_PER,
                        CASE WHEN O.NRSCORE > 100
                             THEN 100
                             WHEN O.NRSCORE < 1
                             THEN 1
                             WHEN O.NRSCORE IS NULL
                             THEN 1
                             ELSE O.NRSCORE
                         END AS NRSCORE,
                         CASE WHEN OPO.IDPERCPIMP = 'S'
                             THEN 'B'
                             WHEN TO_NUMBER(NVL(OPO.VRTOTALFATU, 0)) > TO_NUMBER($minRevenue)
                             THEN 'S'
                             ELSE 'N'
                         END AS IDPERCPIMP
                   FROM ORGANIZACAO O
             INNER JOIN CLIENTE CLI    ON (CLI.NRPARCNEGOCIO = O.NRPARCNEGOCIO AND CLI.IDCLIEATIV = 'S')
              LEFT JOIN ORGANIZACAO OM ON (O.NRORGPRINCIPAL = OM.NRORG)
              LEFT JOIN OPERADOR OP1   ON OP1.CDOPERADOR = O.CDOPERPADRINHO
              LEFT JOIN OPERADOR OP2   ON OP2.CDOPERADOR = O.CDOPERGERENTE
              $join
              LEFT JOIN (SELECT CLIE.CDCLIENTE,
                                CEIL(SUM(NVL(MED.VRMEDICAO, NVL(CARENCIA.VRTOTITEMCOMDESC, NEG.VRTOTITEMCOMDESC))) / 100000 * 100) AS VRTOTAL
                           FROM FCT_CONTRATO CONT
                          INNER JOIN FCT_NEGOCIACAOCONTRATO NEG
                             ON CONT.NRSEQCONTRATO = NEG.NRSEQCONTRATO
                          INNER JOIN CLIENTE CLIE
                             ON CONT.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO
                           LEFT JOIN FCT_MEDICAOFATURA MED
                             ON CONT.NRSEQCONTRATO = MED.NRSEQCONTRATO
                            AND MED.IDSITUACAO     IN ('3', '4')
                            AND TRUNC(SYSDATE) BETWEEN TRUNC(MED.DTINICOMPET) AND TRUNC(MED.DTFINCOMPET)
                           LEFT JOIN FCT_DESCPERIODONEGOCONT CARENCIA
                             ON NEG.NRNEGOCIACAOCONTRATO = CARENCIA.NRNEGOCIACAOCONTRATO
                            AND NRORDEMAPLICADESC        = (SELECT MIN(NRORDEMAPLICADESC)
                                                              FROM FCT_DESCPERIODONEGOCONT
                                                             WHERE NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                                                               AND TRUNC(SYSDATE)      <= TRUNC(DTFINALVALIDADEDESC))
                          WHERE TRUNC(NVL(CONT.DTFINVIGENCONT, CONT.DTFIMCONTRATO)) >= TRUNC(SYSDATE)
                            AND CONT.IDSITUACAOCONTRATO = 'A'
                            AND NEG.IDTPFATURA          IN ('A', 'X')
                            AND NEG.NRTIPOORCAMENTO     <> 37
                          GROUP BY CLIE.CDCLIENTE) VAL ON VAL.CDCLIENTE = CLI.CDCLIENTE)
         WHERE 1 = 1

SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
        // $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        // return ($result) ? $result : [];
    }

    public function obtemPorId($minRevenue, $id) {
          $query = "
          SELECT  O.IDTIPOINSCRORG, O.NMRAZSOCIALORG, O.NMORGANIZACAO, O.DSDIRLOG,
               O.NRORG, O.IDATIVO, O.NMACESSO, O.CDPAIS, O.SGESTADO,
               O.CDMUNICIPIO, O.NMBAIREMPR AS SA_BAIRRO, O.NRCEPEMPR, O.NRINSJUREMPR,
               O.NRINSCESTA, O.DSLOGRADEMPR, O.NRLOGRADEMPR, O.DSCMPLOGEMPR,
               O.CDINSCMUNI, O.DSEMAILEMPRESA, O.NRTELEFOEMPR, O.NMOPERADOR, O.DTINCLUSAO,
               O.DSEMAILOPER, SP.NMPAIS AS SA_PAIS, SE.NMESTADO AS SA_ESTADO, O.PREPSTATUS, O.PREPSTATUSBKP,
               O.DTULTATU, O.NRINSCRICAOORG, O.IDTIPOINSCRORG AS TIPOORG,
               DECODE(O.NRORGPRINCIPAL, NULL, O.IDORGSAAS, OM.IDORGSAAS) AS IDORGSAAS,
               O.NRORGPRINCIPAL, SM.NMMUNICIPIO AS SA_MUNICIPIO, OP.QTD_OPERADORES, O.NRPARCNEGOCIO,
               DECODE(O.NRORGPRINCIPAL, NULL, '', (O.NRORGPRINCIPAL || ' - ' || OM.NMORGANIZACAO)) AS NMORGPRINCIPAL,
               DECODE(O.NRORGPRINCIPAL, NULL, 'P', 'S') AS IS_PRIMARY,
               NVL(OPO.VRCNPJFATU, 0) AS VRCNPJFATU, NVL(OPO.VRTOTALFATU, 0) AS VRTOTALFATU,
               CASE WHEN OPO.IDPERCPIMP = 'S'
                    THEN 'S'
                    WHEN TO_NUMBER(NVL(OPO.VRTOTALFATU, 0)) > TO_NUMBER($minRevenue)
                    THEN 'S'
                    ELSE 'N'
               END AS IDPERCPIMP,
               CASE WHEN O.PREPSTATUS IN ('C', 'S', 'N', 'O')
                    THEN 'S'
                    ELSE 'N'
               END AS EDIT_IS_PRIMARY,
               CASE WHEN SEMP.NRORG IS NULL
                    THEN 'N'
                    ELSE 'S'
               END AS ESTA_PREPARADA
          FROM (SELECT COUNT(*) AS QTD_OPERADORES
                    FROM USR_ORG_SAAS.OPERADOR
               WHERE NRORG = :id) OP,
               ORGANIZACAO O
          LEFT JOIN PAIS SP        ON (O.CDPAIS = SP.CDPAIS)
          LEFT JOIN ESTADO SE      ON (O.SGESTADO = SE.SGESTADO AND SE.CDPAIS = SP.CDPAIS)
          LEFT JOIN MUNICIPIO SM   ON (O.CDMUNICIPIO = SM.CDMUNICIPIO AND O.SGESTADO = SM.SGESTADO AND SM.CDPAIS = SP.CDPAIS)
          LEFT JOIN EMPRESA SEMP   ON (O.NRORG = SEMP.NRORG)

          LEFT JOIN ORGANIZACAO OM ON (O.NRORGPRINCIPAL = OM.NRORG)
          LEFT JOIN OM_PARAM_ORG OPO ON (O.NRORG = OPO.NRORG)
          WHERE O.NRORG = :id
          ";
          $param = array("id" => $id);

          return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $param);
     }

    public function findProdutosContratados($nrparcnegocio)
    {
        $query = <<<SQL
           SELECT ID, PARENT_ID, PRIMARY_ID, PARENT_PROPERTY_ID, LABEL, NRORDEM, NRPARCNEGOCIO, ATIVO, MAX(TO_CHAR(VALIDADE, 'DD/MM/YYYY')) AS VALIDADE,
                   rtrim(xmlagg(xmlelement(e,NRCONTRATOFCT ,', ').extract('//text()') order by NRCONTRATOFCT ).GetClobVal(),', ') AS NRCONTRATOFCT,
                     rtrim(xmlagg(xmlelement(e,NRORCAMENTO ,', ').extract('//text()') order by NRORCAMENTO ).GetClobVal(),', ') AS NRORCAMENTO
              FROM (SELECT DISTINCT OME.ID AS ID, DECODE(OME.PARENT_ID, NULL, OMP.ID, OME.PARENT_ID) AS PARENT_ID,
                           TO_CHAR('E'||OME.ID) AS PRIMARY_ID,
                           DECODE(OME.PARENT_ID, NULL, 'P' || OMP.ID, 'E' || OME.PARENT_ID) AS PARENT_PROPERTY_ID,
                           OME.LABEL, OME.NRORDEM, ORG.NRPARCNEGOCIO,
                           CASE WHEN ((OEG.DTVALIDADE IS NOT NULL AND TRUNC(OEG.DTVALIDADE) >= TRUNC(SYSDATE))
                                      OR (OEG.ID IS NOT NULL AND OEG.DTVALIDADE IS NULL))
                                THEN 'S'
                                ELSE 'N'
                            END AS ATIVO, OEG.DTVALIDADE AS VALIDADE,
                            DECODE(TSO.NRSEQORCAMENTO, NULL, NULL, CON.NRCONTRATOFCT) AS NRCONTRATOFCT,
                             DECODE(TSO.NRSEQORCAMENTO, NULL, NULL, ORC.NRORCAMENTO) AS NRORCAMENTO
                            FROM OM_PRODUTO               OMP
                      JOIN OM_PRODUTO_ELEMENTO      OME ON OME.NRPRODUTO_ID          = OMP.ID
                      JOIN OM_PRODUTO_ORG           OMG ON OMG.NRPRODUTO_ID          = OMP.ID
                 LEFT JOIN OM_PRODUTO_ORG_ELEMENTO  OEG ON OEG.NRPRODUTO_ORG_ID      = OMG.ID
                                                       AND OEG.NRPRODUTO_ELEMENTO_ID = OME.ID
                      JOIN ORGANIZACAO              ORG ON ORG.NRORG                 = OMG.NRORG_ID
                 LEFT JOIN FCT_CONTRATO             CON ON CON.NRPARCNEGOCIO         = ORG.NRPARCNEGOCIO
                                                       AND CON.IDSITUACAOCONTRATO    = 'A'
                 LEFT JOIN FCT_REFEORCACONT         REF ON REF.NRSEQCONTRATO         = CON.NRSEQCONTRATO
                   LEFT JOIN FCT_ORCAMENTO    ORC   ON REF.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                 LEFT JOIN FCT_TRABSERVORCAMENTO    TSO ON TSO.NRSEQORCAMENTO        = REF.NRSEQORCAMENTO
                                                       AND TSO.IDESCOLHIDO           = 'S'
                                                       AND OME.UNIQUE_ID             = REPLACE(TSO.IDELEMENTO, 'P_' || OMP.ID || '_M_', '')
                     WHERE OME.IDATIVO = 'S'
                       AND ORG.NRPARCNEGOCIO = :NRPARCNEGOCIO

                  UNION

                  SELECT ID, PARENT_ID, PRIMARY_ID, PARENT_PROPERTY_ID, LABEL,
                         NRORDEM, NRPARCNEGOCIO, ATIVO, MAX(VALIDADE), NRCONTRATOFCT, NRORCAMENTO
                    FROM (SELECT DISTINCT OMP.ID AS ID, NULL AS PARENT_ID, TO_CHAR('P' || OMP.ID) AS PRIMARY_ID,
                                 NULL AS PARENT_PROPERTY_ID, OMP.NMPRODUTO AS LABEL, 0 AS NRORDEM, ORG.NRPARCNEGOCIO,
                                 'P' AS ATIVO, OEG.DTVALIDADE AS VALIDADE, DECODE(TRA.NRSEQORCAMENTO, NULL, NULL, CON.NRCONTRATOFCT) AS NRCONTRATOFCT,
                                 DECODE(TRA.NRSEQORCAMENTO, NULL, NULL, ORC.NRORCAMENTO) AS NRORCAMENTO
                            FROM OM_PRODUTO              OMP
                            JOIN OM_PRODUTO_ELEMENTO     OME ON OME.NRPRODUTO_ID     = OMP.ID
                            JOIN OM_PRODUTO_ORG          OMG ON OMG.NRPRODUTO_ID     = OMP.ID
                       LEFT JOIN OM_PRODUTO_ORG_ELEMENTO OEG ON OEG.NRPRODUTO_ORG_ID = OMG.ID
                                                            AND OEG.NRPRODUTO_ELEMENTO_ID = OME.ID
                            JOIN ORGANIZACAO             ORG ON ORG.NRORG              = OMG.NRORG_ID
                       LEFT JOIN FCT_CONTRATO            CON ON CON.NRPARCNEGOCIO      = ORG.NRPARCNEGOCIO
                                                            AND CON.IDSITUACAOCONTRATO = 'A'
                       LEFT JOIN FCT_REFEORCACONT        REF ON REF.NRSEQCONTRATO      = CON.NRSEQCONTRATO
                       LEFT JOIN FCT_ORCAMENTO    ORC   ON REF.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                       LEFT JOIN FCT_TRABSERVORCAMENTO   TRA ON TRA.NRSEQORCAMENTO     = REF.NRSEQORCAMENTO
                                                            AND TRA.IDESCOLHIDO        = 'S'
                                                            AND OME.UNIQUE_ID          = REPLACE(TRA.IDELEMENTO, 'P_' || OMP.ID || '_M_', '')
                   WHERE OME.IDATIVO = 'S'
                     AND ORG.NRPARCNEGOCIO = :NRPARCNEGOCIO)
                GROUP BY ID, PARENT_ID, PRIMARY_ID, PARENT_PROPERTY_ID, LABEL,
                         NRORDEM, NRPARCNEGOCIO, ATIVO, NRCONTRATOFCT, NRORCAMENTO
               )
    	     WHERE 1 = 1
          GROUP BY ID, PARENT_ID, PRIMARY_ID, PARENT_PROPERTY_ID, LABEL, NRORDEM, NRPARCNEGOCIO, ATIVO
          ORDER BY NRORDEM, LABEL
SQL;
        $params = array(
            'NRPARCNEGOCIO' => $nrparcnegocio
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }

    public function getRelacionadas($nrorg) 
    {
        $query = <<<SQL
        SELECT *
          FROM ( SELECT NRORG, NMRAZSOCIALORG, NMORGANIZACAO, PREPSTATUS, IDATIVO, IDTIPOINSCRORG, 
                        IDORGSAAS, NRORGPRINCIPAL, PREPSTATUS AS ORGSTATUS
                   FROM ORGANIZACAO
                  WHERE NRORGPRINCIPAL = :nrorg
                    AND IDATIVO = 'S' )
         WHERE 1=1
SQL;
        $params = array(
            "nrorg" => $nrorg
        );
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }
}
