<?php

namespace OrganizationsManagement\Service\Login;

use OrganizationsManagement\Util\Utilities;
use Doctrine\ORM\EntityManager;

class Login {
    /** @var EntityManager **/
    protected $entityManager;

    /** @var \Teknisa\Model\Geral\Repositories\Operador */
    protected $operadorRepository;

    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
        $this->operadorRepository = $entityManager->getRepository(Utilities::GERAL_ENTITY_DIR . 'Operador');
    }

    public function validateUserAfterLogin($operatorCode, $orgId) {
        /** @var \Teknisa\Model\Geral\Entities\Operador $operator */
        $operator = $this->operadorRepository->findOneBy(array('cdoperador' => $operatorCode, 'nrorg' => $orgId));
        if(!$operator || empty($operator->getCdfunc())) {
            return false;
        }
        return true;
    }
}